﻿using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System;
using System.Windows;

//using ThinkGeo.MapSuite.Core;
using WPCore=ThinkGeo.MapSuite.WindowsPhoneCore;
using ThinkGeo.MapSuite.WindowsPhoneEdition;
using Xamarin.Forms;
using Xamarin.Forms.Platform.WinPhone;
using Color = System.Windows.Media.Color;
using Point = System.Windows.Point;
using Agtrix.MapSuitForms;
using Agtrix.MapSuitForms.WP.Renderers;
//using Core=ThinkGeo.MapSuite.Core;


[assembly: ExportRenderer(typeof(FormsViewMap), typeof(MapViewRenderer_WP))]
namespace Agtrix.MapSuitForms.WP.Renderers
{
    public class MapViewRenderer_WP : ViewRenderer<FormsViewMap, Map>
    {
        ThinkGeo.MapSuite.WindowsPhoneEdition.Map nativeMap = new ThinkGeo.MapSuite.WindowsPhoneEdition.Map() { Width = 480, Height = 620, MapUnit = WPCore.GeographyUnit.Meter };
       
        private bool isTracking;
        private bool isRecording;
        private MarkerOverlay gpsOverlay;
        private Marker locationMarker;
        private BitmapImage markerImage = new BitmapImage(new Uri("/Images/Pin.png", UriKind.RelativeOrAbsolute));
        private ThinkGeo.MapSuite.WindowsPhoneEdition.BingMapsOverlay bingMapOverlay;
        protected static readonly WPCore.GeoColor BrushColor = WPCore.GeoColor.FromArgb(100, 0, 147, 221);
        private double CurrentScale = 18055.99;
        WPCore.Proj4Projection wgs84ToBingProjection = new WPCore.Proj4Projection();
        protected Collection<WPCore.Feature> GeometrySource = new Collection<WPCore.Feature>();
        public WPCore.InMemoryFeatureLayer SourceFeatureLayer { get; set; }
        protected override void OnElementChanged(ElementChangedEventArgs<FormsViewMap> e)
        {
            base.OnElementChanged(e);
            
            if (e.OldElement != null || this.Element == null)
                return;
            nativeMap.Loaded += nativeMap_Loaded;
            
            this.SetNativeControl(nativeMap);
        }

        void nativeMap_Loaded(object sender, RoutedEventArgs e)
        {
            this.Element.LocationChanged += LocationChanged;
            this.Element.LayerChanged += LayerChanged;
            nativeMap.SizeChanged += map_SizeChanged;
            nativeMap.ManipulationCompleted += mapView_OnManipulationCompleted;
            nativeMap.Background = new SolidColorBrush(Color.FromArgb(255, 156, 187, 216));
            
            

            #region setup wgs84ToBingProjection and set map extent to farms BondingBox

            wgs84ToBingProjection.InternalProjectionParameters = WPCore.Proj4Projection.GetWgs84ParametersString();
            wgs84ToBingProjection.ExternalProjectionParameters = WPCore.Proj4Projection.GetBingMapParametersString();

            #endregion

            #region Load farm features
            //agtrix farm
            var wkt = "MULTIPOLYGON (((153.524037 -28.498472, 153.523862 -28.498368, 153.523872 -28.498313, 153.522815 -28.49754, 153.522267 -28.497456, 153.522085 -28.497335, 153.52199 -28.496912, 153.521821 -28.496851, 153.521158 -28.496832, 153.520307 -28.496703, 153.519958 -28.495789, 153.519853 -28.495047, 153.520196 -28.49465, 153.51935 -28.49412, 153.518921 -28.494059, 153.518301 -28.493425, 153.518185 -28.493528, 153.518079 -28.493408, 153.517854 -28.493586, 153.516154 -28.495845, 153.515681 -28.496111, 153.515611 -28.496495, 153.515958 -28.497056, 153.515952 -28.497245, 153.515541 -28.497192, 153.515151 -28.499144, 153.515572 -28.498816, 153.516452 -28.499015, 153.516862 -28.498971, 153.516972 -28.498986, 153.51762 -28.499208, 153.517913 -28.499438, 153.516892 -28.499142, 153.516472 -28.499215, 153.515602 -28.499017, 153.51511 -28.499395, 153.514964 -28.500276, 153.515872 -28.500527, 153.516602 -28.500785, 153.518452 -28.501494, 153.519034 -28.501611, 153.518397 -28.505074, 153.522304 -28.505621, 153.523145 -28.500816, 153.523428 -28.500727, 153.523604 -28.499773, 153.523288 -28.499487, 153.523127 -28.499221, 153.522288 -28.499088, 153.522007 -28.498937, 153.521256 -28.499067, 153.520954 -28.498921, 153.520459 -28.498929, 153.519935 -28.499166, 153.518793 -28.499317, 153.518742 -28.499156, 153.519872 -28.498996, 153.52001 -28.498945, 153.520416 -28.498749, 153.520994 -28.498739, 153.521282 -28.498878, 153.522006 -28.498734, 153.522368 -28.498909, 153.523262 -28.499055, 153.523218 -28.498984, 153.523419 -28.49846, 153.523832 -28.498522, 153.524037 -28.498472)), ((153.528358 -28.505154, 153.528186 -28.504247, 153.528127 -28.5042, 153.527784 -28.504181, 153.52791 -28.505227, 153.528056 -28.505199, 153.528358 -28.505154)))";
            //os
            //wkt ="POLYGON ((67.06344634859065 24.86872928232485,67.06350011149192 24.86854753153191,  67.06377458445243 24.86860149931578, 67.0637262990391 24.86878262955275,  67.06344634859065 24.86872928232485))";
            //thinkgeo sample
            //wkt ="MULTIPOLYGON(((-10773853.9939131 3915095.87026741,-10773854.1456889 3915086.53993123,-10773840.8550831 3915086.43205917,-10773841.5178371 3915045.69011131,-10773844.4728399 3915045.68991754,-10773844.7666422 3915027.62946101,-10773841.6301727 3915027.60401401,-10773838.5087838 3914990.27224618,-10773849.5202388 3914990.37489533,-10773850.4108089 3914990.38316008,-10773852.5196598 3914990.40284123,-10773864.2420067 3914990.51210623,-10773865.3100244 3914990.52050579,-10773865.6318511 3914990.52308552,-10773885.702009 3914990.68171477,-10773907.2529321 3914990.85273977,-10773928.712972 3914991.02226961,-10773950.2638588 3914991.19328748,-10773971.8118494 3914991.54692845,-10773993.3627748 3914991.71783057,-10774014.8227454 3914991.88716393,-10774030.9671177 3914992.01398891,-10774036.191869 3914992.05500389,-10774057.4700367 3914992.22134916,-10774080.2908714 3914992.59566829,-10774080.2870555 3914993.07904488,-10774080.0381829 3915024.93780374,-10774079.8064062 3915039.20301602,-10774079.6519006 3915048.71239972,-10774086.1925963 3915049.16145093,-10774089.1899913 3915049.39335887,-10774090.1901488 3915049.40976218,-10774094.1905971 3915049.47537159,-10774098.1911181 3915049.5409808,-10774100.191324 3915049.573784,-10774100.2864745 3915088.50072546,-10774100.2958244 3915092.31626746,-10774100.3066516 3915096.75742022,-10774100.3070515 3915096.90746346,-10774095.4221127 3915096.82735034,-10774094.8765535 3915096.81840303,-10774094.3310307 3915096.80945629,-10774093.7855442 3915096.80051012,-10774093.2400214 3915096.79156333,-10774092.6944622 3915096.78261591,-10774092.1489394 3915096.77366907,-10774091.6034529 3915096.7647228,-10774091.0579301 3915096.75577591,-10774090.5123709 3915096.74682839,-10774089.9668481 3915096.73788144,-10774089.4213616 3915096.72893507,-10774088.8758388 3915096.71998808,-10774088.3302796 3915096.71104046,-10774087.7847568 3915096.70209341,-10774087.2392704 3915096.69314693,-10774086.6937476 3915096.68419983,-10774081.7840059 3915096.6036742,-10774060.3208743 3915096.61716282,-10774056.2294171 3915096.55004889,-10774038.7697198 3915096.44634601,-10774023.3132417 3915096.19277063,-10774017.2186381 3915096.27552705,-10773995.8493615 3915096.10765138,-10773974.2982077 3915095.9367883,-10773958.2023188 3915095.85534544,-10773952.6532376 3915095.94702116,-10773931.1020847 3915095.77607811,-10773918.2793679 3915095.74834313,-10773916.3761255 3915095.78786068,-10773890.8957174 3915096.3174372,-10773890.9788759 3915091.20432421,-10773866.9896273 3915091.4283585,-10773866.6816008 3915091.409156,-10773866.3733414 3915091.39532247,-10773866.0648123 3915091.38689387,-10773865.7562315 3915091.38387377,-10773865.4475986 3915091.38629872,-10773865.1391328 3915091.39409921,-10773864.8307967 3915091.40734774,-10773864.5227364 3915091.42601014,-10773864.215062 3915091.45001514,-10773863.9078088 3915091.47943641,-10773863.6011956 3915091.51424098,-10773863.2951861 3915091.55442829,-10773862.9898904 3915091.599927,-10773862.6854887 3915091.65084975,-10773862.3819834 3915091.70705037,-10773862.0795557 3915091.7685684,-10773861.7781691 3915091.83540322,-10773861.4780063 3915091.90752129,-10773861.1791774 3915091.98485133,-10773860.8816825 3915092.06739332,-10773860.5857391 3915092.15518739,-10773860.2912757 3915092.24815927,-10773859.9985118 3915092.34623947,-10773859.7075558 3915092.4494663,-10773859.4183362 3915092.55776552,-10773859.1311075 3915092.67114127,-10773858.8459073 3915092.7895211,-10773858.5627363 3915092.91286845,-10773858.2818125 3915093.04118692,-10773858.0031731 3915093.17444055,-10773857.7268566 3915093.3124838,-10773857.4529711 3915093.45539152,-10773857.1815905 3915093.60309183,-10773856.9128244 3915093.75554999,-10773856.6468208 3915093.91262223,-10773856.3835056 3915094.07438042,-10773856.1230989 3915094.24071854,-10773855.8655649 3915094.41159944,-10773855.6110861 3915094.58698959,-10773855.3596272 3915094.76681528,-10773855.1113707 3915094.95104298,-10773854.8663917 3915095.13952772,-10773854.6246526 3915095.33234199,-10773854.3863384 3915095.52930605,-10773854.1514483 3915095.73045646,-10773853.9939131 3915095.87026741)))";
            GeometrySource.Clear();
            nativeMap.Overlays.Clear();
            
            wgs84ToBingProjection.Open();
            WPCore.BaseShape poly;
            WPCore.Feature f;

            #region add farm features

            try
            {
                
                    if (wkt.Contains("MULTIPOLYGON"))
                    {
                        poly = new WPCore.MultipolygonShape(wkt);
                        f = new WPCore.Feature((WPCore.MultipolygonShape)wgs84ToBingProjection.ConvertToExternalProjection(poly));
                    }
                    else
                    {
                        poly = new WPCore.PolygonShape(wkt);
                        f = new WPCore.Feature((WPCore.PolygonShape)wgs84ToBingProjection.ConvertToExternalProjection(poly));
                        //,farm.Name, new List<string> {farm.Name});    
                    }

                    f.ColumnValues.Add("Name", "XYZ Label");
                    GeometrySource.Add(f);

            }
            catch (Exception err)
            {
                Console.WriteLine(err);

            }
            #endregion

            wgs84ToBingProjection.Close();

            #endregion

            #region setup extent,zoom level, etc
            //CurrentScale = nativeMap.ZoomLevelSet.ZoomLevel20.Scale;
            wgs84ToBingProjection.Open();
            var mapExtent = (WPCore.RectangleShape)WPCore.ExtentHelper.GetBoundingBoxOfItems(GeometrySource).CloneDeep();
            mapExtent = wgs84ToBingProjection.ConvertToExternalProjection(mapExtent);
            wgs84ToBingProjection.Close();
            nativeMap.CurrentExtent = mapExtent;
            nativeMap.ZoomToScale(CurrentScale);
            mapExtent.ScaleUp(100);


            //nativeMap.ZoomTo();
            nativeMap.Background = new SolidColorBrush(Color.FromArgb(255, 156, 187, 216));
            //nativeMap.MapTools.MouseCoordinate.IsEnabled = true;
            //CurrentScale = nativeMap.ZoomLevelSet.ZoomLevel18.Scale;
            //nativeMap.ZoomToScale(CurrentScale);
            #endregion

            #region Create farm Labels
            var textStyle = WPCore.TextStyles.CreateSimpleTextStyle(
  "Name", "Arial", 8, false, WPCore.GeoColor.StandardColors.Black, 0, 0);
            textStyle.HaloPen = new WPCore.GeoPen(WPCore.GeoColor.StandardColors.White, 2);
            textStyle.OverlappingRule = WPCore.LabelOverlappingRule.NoOverlapping;
            textStyle.SplineType = WPCore.SplineType.ForceSplining;
            textStyle.DuplicateRule = WPCore.LabelDuplicateRule.UnlimitedDuplicateLabels;
            textStyle.TextLineSegmentRatio = 9999999;
            textStyle.FittingLineInScreen = true;
            textStyle.SuppressPartialLabels = true;
            textStyle.BestPlacement = true;
            #endregion

            #region Create InMemoryFeatureLayer and fill Farm feratures in it
            SourceFeatureLayer = new WPCore.InMemoryFeatureLayer();
            SourceFeatureLayer.Open();
            SourceFeatureLayer.Columns.Add(new WPCore.FeatureSourceColumn("Name"));

            SourceFeatureLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = new WPCore.AreaStyle(new WPCore.GeoSolidBrush(BrushColor));
            //SourceFeatureLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle.OutlinePen.Width = 3;
            SourceFeatureLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle.OutlinePen.Color = WPCore.GeoColor.SimpleColors.Black;
            SourceFeatureLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = WPCore.ApplyUntilZoomLevel.Level20;
            SourceFeatureLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle = textStyle;// new TextStyle("Name", new GeoFont("Arail", 9, DrawingFontStyles.Bold), new GeoSolidBrush(GeoColor.SimpleColors.Black));
            SourceFeatureLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = WPCore.LineStyles.SecondaryRoad2;

            foreach (WPCore.Feature feature in GeometrySource)
            {
                SourceFeatureLayer.InternalFeatures.Add(feature);
            }

            #endregion

            #region create and add BingMapsTileOverlay as base

                    var bingKey = "Put Bing Key Here";
                    bingMapOverlay = new ThinkGeo.MapSuite.WindowsPhoneEdition.BingMapsOverlay("Agtrix", bingKey, BingMapsStyle.Hybrid);
                    bingMapOverlay.BingMapsStyle = BingMapsStyle.Hybrid;
                    //nativeMap.CurrentExtent = bingMapOverlay.GetBoundingBox();
                    nativeMap.Overlays.Add("bing", bingMapOverlay);
               
            #endregion

            //caching
#if RELEASE
                baseOverlay.TileCache = new IsolatedStorageFileNativeImageTileCache();
#endif
            #region add other overlays: marker/gps overlay and SourceFeatureLayer overlay and popupOverlay
            SimpleMarkerOverlay gpsOverlay = new SimpleMarkerOverlay();
            nativeMap.Overlays.Add("GpsOverlay", gpsOverlay);

            LayerOverlay layerOverlay = new LayerOverlay();
            layerOverlay.Layers.Add("SourceLayer", SourceFeatureLayer);
            nativeMap.Overlays.Add("LayerOverlay", layerOverlay);
            nativeMap.Background = new SolidColorBrush(Color.FromArgb(255, 156, 187, 216));
            nativeMap.MapTools.MouseCoordinate.IsEnabled = true;

            // mapView.Overlays.Add("popupOverLay", popupOverlay);
            //navigateToCurrentPosition(new Xamarin.Forms.Point{X=App.LocationSvc.CurrentPosition.Longitude,Y=App.LocationSvc.CurrentPosition.Latitude});
            #endregion
            nativeMap.Refresh();
            //isTracking = true;
            //var currentLocation = new Xamarin.Forms.Point(153.5281, -28.5046);
            //navigateToCurrentPosition(currentLocation);
        }
        private void mapView_OnManipulationCompleted(object sender, ManipulationCompletedEventArgs e)
        {
            CurrentScale = nativeMap.CurrentScale;
            
        }
        private void LayerChanged(object sender, string e)
        {
            bingMapOverlay.BingMapsStyle = e == "Bing Street" ? BingMapsStyle.Roads : BingMapsStyle.Hybrid;
            nativeMap.Refresh();

        }
        
        private int numPositions;
        private void LocationChanged(object sender, Xamarin.Forms.Point e)
        {
            ++numPositions;
            if (numPositions == 1)
                navigateToLastKnownPosition(e);
            else navigateToCurrentPosition(e);
        }
        /// <summary>
        /// Called when the underlying model's properties are changed.
        /// </summary>
        /// <param name="sender">Model sending the change event.</param>
        /// <param name="e">Event arguments.</param>
        protected async override void OnElementPropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            base.OnElementPropertyChanged(sender, e);

            if (e.PropertyName == Agtrix.MapSuitForms.FormsViewMap.IsTrackingProperty.PropertyName)
            {
                var map = this.Element as Agtrix.MapSuitForms.FormsViewMap;
                if (map != null)
                {
                    isTracking = map.IsTracking;
                }

            }
            if (e.PropertyName == Agtrix.MapSuitForms.FormsViewMap.IsRecordingProperty.PropertyName)
            {
                var map = this.Element as Agtrix.MapSuitForms.FormsViewMap;
                if (map != null)
                {
                    isRecording = map.IsRecording;
                    
                }

            }
        }

        private void map_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            CurrentScale = nativeMap.CurrentScale;
            
        }
        private void navigateToLastKnownPosition(Xamarin.Forms.Point currentLocation)
        {
            if (currentLocation != null)
            {
                try
                {

                    SimpleMarkerOverlay markerOverlay =
                        nativeMap.Overlays.OfType<SimpleMarkerOverlay>().FirstOrDefault();
                    WPCore.PointShape location = new WPCore.PointShape(currentLocation.X, currentLocation.Y);
                    wgs84ToBingProjection.Open();
                    location = (WPCore.PointShape)wgs84ToBingProjection.ConvertToExternalProjection(location);
                    wgs84ToBingProjection.Close();


                    if (markerOverlay != null)
                    {

                        markerOverlay.Markers.Clear();
                        locationMarker = new Marker(location)
                        {
                            ImageSource = markerImage,
                            ImageOffsetX = -28,
                            ImageOffsetY = -32
                        };
                        markerOverlay.Markers.Add(locationMarker);
                    }

                    //center the map to current location
                    
                    nativeMap.MoveTo(location);
                    //nativeMap.ZoomToScale(CurrentScale);



                }

                catch (Exception err)
                {

                    Console.WriteLine(err);
                }
            }
        }

        private bool navigateToCurrentPosition(Xamarin.Forms.Point currentLocation)
        {
            if (!isTracking)
                return false;

            try
            {

                
                SimpleMarkerOverlay markerOverlay = nativeMap.Overlays.OfType<SimpleMarkerOverlay>().FirstOrDefault();
                WPCore.PointShape location = new WPCore.PointShape(currentLocation.X, currentLocation.Y);
                wgs84ToBingProjection.Open();
                location = (WPCore.PointShape)wgs84ToBingProjection.ConvertToExternalProjection(location);
                wgs84ToBingProjection.Close();


                if (markerOverlay != null)
                {
                    markerOverlay.Markers.Clear();
                    locationMarker = new Marker(location)
                    {
                        ImageSource = markerImage,
                        ImageOffsetX = -28,
                        ImageOffsetY = -32
                    };
                    markerOverlay.Markers.Add(locationMarker);
                    markerOverlay.Refresh();
                }
                
                nativeMap.MoveTo(location);
                //nativeMap.Refresh();
               // nativeMap.ZoomToScale(CurrentScale);
           
            }
             
            catch (Exception)
            {

                return false;
            }
            return true;
        }
       
    }
}
